name: master

on:
  push:
    branches:
      - master

jobs:
  build:
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@master
      - name: Setup dotnet core '3.1.100'
        uses: actions/setup-dotnet@v1
        with:
          dotnet-version: '3.1.100'
      - name: Build with dotnet
        run: dotnet build otp_service.sln
      - name: Run unit tests
        run: dotnet test otp_service.sln
      - name: Set env
        run: echo ::set-env name=RELEASE_VERSION::$(echo $GITHUB_SHA | head -c7)
      - name: Test coverage
        run: dotnet test test/In.ProjectEKA.OtpServiceTest/In.ProjectEKA.OtpServiceTest.csproj /p:CollectCoverage=true /p:CoverletOutputFormat=opencover
      - name: Docker Registry
        env:
          DOCKER_REGISTRY_URL: docker.io
          DOCKER_PASSWORD: ${{ secrets.SE_DOCKER_PASSWORD }}
          DOCKER_USERNAME: ${{ secrets.SE_DOCKER_USERNAME }}
        run: |
          docker login -u $DOCKER_USERNAME -p $DOCKER_PASSWORD $DOCKER_REGISTRY_URL
      - name: Build docker image
        env:
          CONTAINER_REPO_NAME: otp-service
          DOCKER_USERNAME: ${{ secrets.SE_DOCKER_USERNAME }}
        run: docker build -t $DOCKER_USERNAME/$CONTAINER_REPO_NAME:$RELEASE_VERSION .
      - name: Push Docker Container to Registry
        env:
          CONTAINER_REPO_NAME: otp-service
          DOCKER_USERNAME: ${{ secrets.SE_DOCKER_USERNAME }}
        run: docker push $DOCKER_USERNAME/$CONTAINER_REPO_NAME:$RELEASE_VERSION
  sonarCodeAnalysis:
    name: Code Analysis
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@master
      - name: SonarCloud Scan
        uses: sonarsource/sonarcloud-github-action@master
        env:
          GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }}
          SONAR_TOKEN: ${{ secrets.SONAR_TOKEN }}
